=encoding utf8

=head1 NAME

Mail::Box::Mbox - handle folders in Mbox format

=head1 INHERITANCE

 Mail::Box::Mbox
   is a Mail::Box::File
   is a Mail::Box
   is a Mail::Reporter

=head1 SYNOPSIS

 use Mail::Box::Mbox;
 my $folder = Mail::Box::Mbox->new(folder => $ENV{MAIL}, ...);

=head1 DESCRIPTION

This documentation describes how Mbox mailboxes work, and also describes
what you can do with the Mbox folder object Mail::Box::Mbox.

Extends L<"DESCRIPTION" in Mail::Box::File|Mail::Box::File/"DESCRIPTION">.
 
=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Box::File|Mail::Box::File/"OVERLOADED">.
 
=over 4

=item overload: B<"">

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<@{}>

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<cmp>

Inherited, see L<Mail::Box/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Box::File|Mail::Box::File/"METHODS">.
 
=head2 Constructors

Extends L<"Constructors" in Mail::Box::File|Mail::Box::File/"Constructors">.
 
=over 4

=item Mail::Box::Mbox-E<gt>B<new>(%options)

 -Option             --Defined in     --Default
  access               Mail::Box        'r'
  body_delayed_type    Mail::Box        Mail::Message::Body::Delayed
  body_type            Mail::Box::File  <see description>
  coerce_options       Mail::Box        []
  create               Mail::Box        <false>
  extract              Mail::Box        10240
  field_type           Mail::Box        undef
  fix_headers          Mail::Box        <false>
  folder               Mail::Box        $ENV{MAIL}
  folderdir            Mail::Box        $ENV{HOME}.'/Mail'
  head_delayed_type    Mail::Box        Mail::Message::Head::Delayed
  head_type            Mail::Box        Mail::Message::Head::Complete
  keep_dups            Mail::Box        <false>
  lock_extension       Mail::Box::File  '.lock'
  lock_file            Mail::Box        <foldername><lock-extension>
  lock_timeout         Mail::Box        1 hour
  lock_type            Mail::Box        Mail::Box::Locker::DotLock
  lock_wait            Mail::Box        10 seconds
  locker               Mail::Box        undef
  log                  Mail::Reporter   'WARNINGS'
  manager              Mail::Box        undef
  message_type         Mail::Box        Mail::Box::Mbox::Message
  multipart_type       Mail::Box        Mail::Message::Body::Multipart
  remove_when_empty    Mail::Box        <true>
  save_on_exit         Mail::Box        <true>
  subfolder_extension                   '.d'
  trace                Mail::Reporter   'WARNINGS'
  trusted              Mail::Box        <depends on folder location>
  write_policy         Mail::Box::File  undef

=over 2

=item access => MODE

=item body_delayed_type => CLASS

=item body_type => CLASS|CODE

=item coerce_options => ARRAY

=item create => BOOLEAN

=item extract => INTEGER | CODE | METHOD | 'LAZY'|'ALWAYS'

=item field_type => CLASS

=item fix_headers => BOOLEAN

=item folder => FOLDERNAME

=item folderdir => DIRECTORY

=item head_delayed_type => CLASS

=item head_type => CLASS

=item keep_dups => BOOLEAN

=item lock_extension => FILENAME|STRING

=item lock_file => FILENAME

=item lock_timeout => SECONDS

=item lock_type => CLASS|STRING|ARRAY

=item lock_wait => SECONDS

=item locker => OBJECT

=item log => LEVEL

=item manager => MANAGER

=item message_type => CLASS

=item multipart_type => CLASS

=item remove_when_empty => BOOLEAN

=item save_on_exit => BOOLEAN

=item subfolder_extension => STRING

Mbox folders do not support sub-folders.  However, this module can
simulate sub-directories if the user wants it to.  When a subfolder of
folder C<xyz> is created, we create a directory which is called C<xyz.d>
to contain them.  This extension C<.d> can be changed using this option.

=item trace => LEVEL

=item trusted => BOOLEAN

=item write_policy => 'REPLACE'|'INPLACE'|undef

=back

=back

=head2 The folder

Extends L<"The folder" in Mail::Box::File|Mail::Box::File/"The folder">.
 
=over 4

=item $obj-E<gt>B<addMessage>($message, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<addMessages>(@messages)

Inherited, see L<Mail::Box/"The folder">

=item Mail::Box::Mbox-E<gt>B<appendMessages>(%options)

Inherited, see L<Mail::Box::File/"METHODS">

=item $obj-E<gt>B<close>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<copyTo>($folder, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<delete>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<filename>()

Inherited, see L<Mail::Box::File/"The folder">

=item $obj-E<gt>B<folderdir>( [$directory] )

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<organization>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<update>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<url>()

Inherited, see L<Mail::Box/"The folder">

=back

=head2 Folder flags

Extends L<"Folder flags" in Mail::Box::File|Mail::Box::File/"Folder flags">.
 
=over 4

=item $obj-E<gt>B<access>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<writable>()

Inherited, see L<Mail::Box/"Folder flags">

=back

=head2 The messages

Extends L<"The messages" in Mail::Box::File|Mail::Box::File/"The messages">.
 
=over 4

=item $obj-E<gt>B<current>( [$number|$message|$message_id] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<find>($message_id)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<findFirstLabeled>( $label, [BOOLEAN, [$msgs]] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<message>( $index, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageId>( $message_id, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageIds>()

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messages>( <'ALL'|$range|'ACTIVE'|'DELETED'|$label| !$label|$filter> )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<nrMessages>(%options)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<scanForMessages>($message, $message_ids, $timespan, $window)

Inherited, see L<Mail::Box/"The messages">

=back

=head2 Sub-folders

Extends L<"Sub-folders" in Mail::Box::File|Mail::Box::File/"Sub-folders">.
 
=over 4

=item $obj-E<gt>B<listSubFolders>(%options)

=item Mail::Box::Mbox-E<gt>B<listSubFolders>(%options)

 -Option             --Defined in     --Default
  check                Mail::Box        <false>
  folder               Mail::Box        <from calling object>
  folderdir            Mail::Box        <from folder>
  skip_empty           Mail::Box        <false>
  subfolder_extension                   <from object>

=over 2

=item check => BOOLEAN

=item folder => FOLDERNAME

=item folderdir => DIRECTORY

=item skip_empty => BOOL

=item subfolder_extension => STRING

When the method is called on an open folder, the extension defined by it is
used to detect sub-folders by default.  Otherwise, C<'.d'> is taken.

=back

=item $obj-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

=item Mail::Box::Mbox-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openRelatedFolder>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openSubFolder>($subname, %options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<topFolderWithMessages>()

=item Mail::Box::Mbox-E<gt>B<topFolderWithMessages>()

Inherited, see L<Mail::Box/"Sub-folders">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box::File|Mail::Box::File/"Internals">.
 
=over 4

=item $obj-E<gt>B<coerce>($message, %options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<create>($foldername, %options)

=item Mail::Box::Mbox-E<gt>B<create>($foldername, %options)

 -Option             --Defined in     --Default
  folderdir            Mail::Box        undef
  subfolder_extension                   undef

=over 2

=item folderdir => DIRECTORY

=item subfolder_extension => STRING

If a directory is found on the location of the folder to be created, this
STRING is used to extend that directory name with.  This will cause the
directory to be seen as sub-folder for the created folder.  This argument
is passed to L<folderToFilename()|Mail::Box::Mbox/"Internals">.

=back

=item $obj-E<gt>B<determineBodyType>($message, $head)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<folderToFilename>( $foldername, $folderdir, [$extension] )

=item Mail::Box::Mbox-E<gt>B<folderToFilename>( $foldername, $folderdir, [$extension] )

Translate a folder name into a filename, using the
$folderdir value to replace a leading C<=>.  If no $extension is specified and
this method is called as instance method, new(subfolder_extension) is used.
Otherwise, the extension default to C<'.d'>.

=item Mail::Box::Mbox-E<gt>B<foundIn>( [$foldername], %options )

If no $foldername is specified, then the value of the C<folder> option
is taken.  A mbox folder is a file which starts with a separator
line: a line with C<'From '> as first characters.  Blank lines which
start the file are ignored, which is not for all MUA's acceptable.

 -Option             --Defined in     --Default
  folder                                undef
  folderdir            Mail::Box        undef
  subfolder_extension                   <from object>

=over 2

=item folder => FOLDERNAME

=item folderdir => DIRECTORY

=item subfolder_extension => STRING

=back

=item $obj-E<gt>B<lineSeparator>( [<STRING|'CR'|'LF'|'CRLF'>] )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<locker>()

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<messageCreateOptions>( [$type, $config] )

Inherited, see L<Mail::Box::File/"Internals">

=item $obj-E<gt>B<moveAwaySubFolder>($directory, $extension)

Inherited, see L<Mail::Box::File/"Internals">

=item $obj-E<gt>B<parser>()

Inherited, see L<Mail::Box::File/"Internals">

=item $obj-E<gt>B<read>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<readMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<storeMessage>($message)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeThreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<updateMessages>(%options)

Inherited, see L<Mail::Box::File/"Internals">

=item $obj-E<gt>B<write>(%options)

Inherited, see L<Mail::Box::File/"Internals">

=item $obj-E<gt>B<writeMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Box::File|Mail::Box::File/"Other methods">.
 
=over 4

=item $obj-E<gt>B<timespan2seconds>($time)

=item Mail::Box::Mbox-E<gt>B<timespan2seconds>($time)

Inherited, see L<Mail::Box/"Other methods">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::File|Mail::Box::File/"Error handling">.
 
=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<addReport>($object)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

=item Mail::Box::Mbox-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<errors>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<log>( [$level, [$strings]] )

=item Mail::Box::Mbox-E<gt>B<log>( [$level, [$strings]] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logPriority>($level)

=item Mail::Box::Mbox-E<gt>B<logPriority>($level)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logSettings>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<report>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<reportAll>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<trace>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<warnings>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::File|Mail::Box::File/"Cleanup">.
 
=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box/"Cleanup">

=back

=head2 DETAILS

Extends L<"DETAILS" in Mail::Box::File|Mail::Box::File/"DETAILS">.
 
=head1 DETAILS

Extends L<"DETAILS" in Mail::Box::File|Mail::Box::File/"DETAILS">.
 
=head2 Different kinds of folders

Extends L<"Different kinds of folders" in Mail::Box::File|Mail::Box::File/"Different kinds of folders">.
 
=head2 Available folder types

Extends L<"Available folder types" in Mail::Box::File|Mail::Box::File/"Available folder types">.
 
=head2 Folder class implementation

Extends L<"Folder class implementation" in Mail::Box::File|Mail::Box::File/"Folder class implementation">.
 
=head2 How MBOX folders work

MBOX folders store many messages in one file.  Each message begins with a
line which starts with the string C<From >.  Lines inside a message which
accidentally start with C<From> are, in the file, preceded by `E<gt>'. This
character is stripped when the message is read.

In this respect must be noted that the format of the MBOX files is not
strictly defined.  The exact content of the separator lines differ between
Mail User Agents (MUA's).  Besides, some MUAs (like mutt) forget to encode
the C<From > lines within message bodies, breaking other parsers....

=head2 Simulation of sub-folders

MBOX folders do not have a sub-folder concept as directory based folders
do, but this MBOX module tries to simulate them.  In this implementation
a directory like

 Mail/subject1/

is taken as an empty folder C<Mail/subject1>, with the folders in that
directory as sub-folders for it.  You may also use

 Mail/subject1
 Mail/subject1.d/

where C<Mail/subject1> is the folder, and the folders in the
C<Mail/subject1.d> directory are used as sub-folders.  If your situation
is similar to the first example and you want to put messages in that empty
folder, the directory is automatically (and transparently) renamed, so
that the second situation is reached.

=head1 DIAGNOSTICS

=over 4

=item Error: Cannot append messages to folder file $filename: $!

Appending messages to a not-opened file-organized folder may fail when the
operating system does not allow write access to the file at hand.

=item Error: Cannot move away sub-folder $dir

=item Warning: Cannot remove folder $name file $filename: $!

Writing an empty folder will usually cause that folder to be removed,
which fails for the indicated reason.  L<new(remove_when_empty)|Mail::Box/"Constructors">

=item Warning: Cannot remove folder $name file $filename: $!

Writing an empty folder will usually cause that folder to be removed,
which fails for the indicated reason.  L<new(remove_when_empty)|Mail::Box/"Constructors">
controls whether the empty folder will removed; setting it to false
(C<0>) may be needed to avoid this message.

=item Error: Cannot replace $filename by $tempname, to update folder $name: $!

The replace policy wrote a new folder file to update the existing, but
was unable to give the final touch: replacing the old version of the
folder file for the indicated reason.

=item Warning: Changes not written to read-only folder $self.

You have opened the folder read-only --which is the default set
by L<new(access)|Mail::Box/"Constructors">--, made modifications, and now want to close it.
Set L<close(force)|Mail::Box/"The folder"> if you want to overrule the access mode, or close
the folder with L<close(write)|Mail::Box/"The folder"> set to C<NEVER>.

=item Error: Copying failed for one message.

For some reason, for instance disc full, removed by external process, or
read-protection, it is impossible to copy one of the messages.  Copying will
proceed for the other messages.

=item Error: Destination folder $name is not writable.

The folder where the messages are copied to is not opened with write
access (see L<new(access)|Mail::Box/"Constructors">).  This has no relation with write permission
to the folder which is controlled by your operating system.

=item Warning: Different messages with id $msgid

The message id is discovered more than once within the same folder, but the
content of the message seems to be different.  This should not be possible:
each message must be unique.

=item Error: File too short to get write message $nr ($size, $need)

Mail::Box is lazy: it tries to leave messages in the folders until they
are used, which saves time and memory usage.  When this message appears,
something is terribly wrong: some lazy message are needed for updating the
folder, but they cannot be retrieved from the original file anymore.  In
this case, messages can be lost.

This message does appear regularly on Windows systems when using the
'replace' write policy.  Please help to find the cause, probably something
to do with Windows incorrectly handling multiple filehandles open in the
same file.

=item Error: Folder $name not deleted: not writable.

The folder must be opened with write access via L<new(access)|Mail::Box/"Constructors">, otherwise
removing it will be refused.  So, you may have write-access according to
the operating system, but that will not automatically mean that this
C<delete> method permits you to.  The reverse remark is valid as well.

=item Error: Invalid timespan '$timespan' specified.

The string does not follow the strict rules of the time span syntax which
is permitted as parameter.

=item Warning: Message-id '$msgid' does not contain a domain.

According to the RFCs, message-ids need to contain a unique random part,
then an C<@>, and then a domain name.  This is made to avoid the creation
of two messages with the same id.  The warning emerges when the C<@> is
missing from the string.

=item Error: Package $package does not implement $method.

Fatal error: the specific package (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.

=item Error: Unable to create subfolder $name of $folder.

The copy includes the subfolders, but for some reason it was not possible
to copy one of these.  Copying will proceed for all other sub-folders.

=item Error: Unable to update folder $self.

When a folder is to be written, both replace and inplace write policies are
tried,  If both fail, the whole update fails.  You may see other, related,
error messages to indicate the real problem.

=back

=head1 SEE ALSO

This module is part of Mail-Box distribution version 3.008,
built on October 04, 2019. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

Copyrights 2001-2019 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.
See F<http://dev.perl.org/licenses/>

